<template>
  <CModal
    :show.sync="isOpen"
    :close-on-backdrop="false"
    addContentClasses="modal-window"
  >
    <template #header>
      <h5>Данные для входа</h5>
      <CButton
        variant="ghost"
        @click="closeModal(false)"
      >
        <CIcon
          name="cilX"
        />
      </CButton>
    </template>
    <template #footer>
      <CButton
        color="secondary"
        @click="closeModal(false)"
      >
        Отмена
      </CButton>
      <CButton
        color="primary"
        @click="closeModal(true)"
      >
        Сохранить
      </CButton>
    </template>
    <CContainer fluid class="editingUser">
      <CRow>
        <CCol>
          <p>{{fullName}}</p>
        </CCol>
      </CRow>
      <CRow>
        <CCol>
          <CInput
            label="Логин"
            v-model="user.login"
            :invalidFeedback="invalidLoginMessage"
            :isValid="isInvalidLogin"
          />
        </CCol>
        <CCol>
          <CInput
            label="Пароль"
            type="password"
            v-model="user.password"
            :invalidFeedback="invalidPasswordMessage"
            :isValid="isInvalidPassword"
          />
        </CCol>
      </CRow>
      <CRow>
        <CCol class="specialActionsContainer">
          <span
            class="specialAction"
            @click="resetPassword"
          >
            Сбросить пароль
          </span>
        </CCol>
      </CRow>
    </CContainer>
  </CModal>
</template>

<script>
  import { mapActions } from 'vuex';
  import modalClosingDuration from "../../../../constants/modalClosingDuration";
  import fieldWarnings from "../../../../constants/fieldWarnings";
  import stringArrayToString from "../../../../utils/stringArrayToString";

  export default {
    name: "EditingUser",
    props: {
      isOpen: {
        // Состояние модального окна
        type: Boolean,
        default: false,
      },
      userInfo: {
        // Информация о редактируемом пользователе
        type: Object,
        default() {
          return {};
        },
      },
      errors: {
        // Ошибки с бека после попытки сохранение изменений данных пользователя
        type: Object,
        default: null,
      },
    },
    data() {
      return {
        user: {},
        userCopy: {},
        warnings: {},
        transformedErrors: null,
      };
    },
    computed: {
      isInvalidLogin() {
        return 'login' in this.warnings ? false : null;
      },
      invalidLoginMessage() {
        return this.isInvalidLogin === false ? this.warnings.login : '';
      },
      isInvalidPassword() {
        return 'password' in this.warnings ? false : null;
      },
      invalidPasswordMessage() {
        return this.isInvalidPassword === false ? this.warnings.password : '';
      },
      fullName() {
        const {role, name} = this.user;
        return `${role ? `${role}:` : ''} ${name}`;
      },
    },
    watch: {
      isOpen(value) {
        if (value) {
          this.user = {...this.userInfo, password: ''};
        } else {
          setTimeout(() => this.clearData(), modalClosingDuration);
        }
      },
      'user.login'(login) {
        // Валидация логина
        if ('login' in this.user) {
          const errors = this.transformedErrors;
          if (errors && 'login' in errors && login === this.userCopy.login) {
            this.$set(this.warnings, 'login', errors.login);
          } else if (login === '') {
            const { emptyField } = fieldWarnings;
            this.$set(this.warnings, 'login', emptyField);
          } else if ('login' in this.warnings) {
            this.$delete(this.warnings, 'login');
          }
        }
      },
      'user.password'(password) {
        // Валидация пароля
        if ('password' in this.user) {
          const {length} = password;
          if (length > 0 && length < 8) {
            const { shortPassword } = fieldWarnings;
            this.$set(this.warnings, 'password', shortPassword);
          } else if ('password' in this.warnings) {
            this.$delete(this.warnings, 'password');
          }
        }
      },
      errors(newErrors) {
        // Отслеживание появления ошибок с бека.
        // Преобразование сообщений ошибок.
        // Копирование текущей информации о заполненых полях.
        // Запись ошибок с бека в локальные ошибки this.warnings.
        if (newErrors && this.isOpen) {
          const userCopy = {};
          const transformedErrors = Object.fromEntries(Object.entries(newErrors).map(([key, value]) => {
            userCopy[key] = this.user[key];
            return [key, stringArrayToString(value)];
          }));
          this.transformedErrors = {...transformedErrors};
          this.userCopy = {...userCopy};
          this.warnings = {...transformedErrors};
        }
      },
    },
    methods: {
      checkValidation() {
        // Проверка корректности данных в полях
        return Object.keys(this.warnings).length === 0;
      },
      closeModal(closeType) {
        if (closeType) {
          if (this.checkValidation()) {
            this.$emit('onClose',
              {closeType, data: {user: this.userInfo, editedUser: this.user}, modalType: 'editUser'},
            );
          }
        } else {
          this.$emit('onClose', {closeType, modalType: 'editUser'});
        }
      },
      resetPassword() {
        // Метод отправки запроса для сброса пароля
        const {id} = this.user;
        this.$store.dispatch('resetPassword', id)
          .then(response => {
            this.addToast({
              toastInfo: response,
              isVisibleToast: true,
              type: 'success',
            })
          })
          .catch(response => {
            let message = '';
            if ('message' in response) message = response.message;
            this.addToast({
              toastInfo: message,
              isVisibleToast: true,
            })
          });
      },
      clearData() {
        this.user = {};
        this.userCopy = {};
        this.warnings = {};
        this.transformedErrors = null;
      },
      ...mapActions({addToast: 'toast/addToast'}),
    }
  }
</script>
